'
' Interface to a 74HC595 serial to parallel shift register
'
    $define SR74_LAT PORTC.0                    ' Choose a pin for the 74HC595 Latch line

    Include "74HC595.inc"                       ' Load the 74HC595 macros into the program
'
' Create a variable to work with
'
    Dim bPattern As Byte                        ' The byte to output via the shift register
'-------------------------------------------------------------------------------------------
' The main demo loop starts here
'
Main:
    bPattern = %00000001                        ' Initialise the byte to send
    While 1 = 1                                 ' Create an infinite loop
        '
        ' Cycle the outputs from Q0 to Q7
        '
        While 1 = 1                             ' Create a loop
            SR_WriteByte(bPattern)              ' Shift out the byte to the 74HC595
            bPattern = bPattern << 1            ' Move the pattern one bit to the left
            If bPattern = %10000000 Then Break  ' Exit the loop when we reach the last bit
            DelayMS 100                         ' Delay so we can see what's going on
        Wend
        DelayMS 100
        '
        ' Cycle the outputs from Q7 to Q0
        '
        While 1 = 1
            SR_WriteByte(bPattern)              ' Shift out the byte to the 74HC595
            bPattern = bPattern >> 1            ' Move the pattern one bit to the right
            If bPattern = %00000001 Then Break  ' Exit the loop when we reach the fist bit
            DelayMS 100                         ' Delay so we can see what's going on
        Wend
        DelayMS 100
    Wend                                        ' Do it forever
